# Overview

[![GoDoc](https://godoc.org/github.com/aws/aws-lambda-go/events?status.svg)](https://godoc.org/github.com/aws/aws-lambda-go/events)

This package provides input types for Lambda functions that process AWS events.

# Samples

[API Gateway](README_ApiGatewayEvent.md)

[API Gateway Custom Authorizer](README_ApiGatewayCustomAuthorizer.md)

[AppSync](README_AppSync.md)

[CloudFormation Events](../cfn/README.md)

[Code Commit Events](README_CodeCommit.md)

[Cognito Events](README_Cognito.md)

[Cognito PostConfirmation](README_Cognito_UserPools_PostConfirmation.md)

[Cognito PreSignup](README_Cognito_UserPools_PreSignup.md)

[Cognito PreTokenGen](README_Cognito_UserPools_PreTokenGen.md)

[Config Events](README_Config.md)

[DynamoDB Events](README_DynamoDB.md)

[Kinesis Events](README_Kinesis.md)

[Kinesis Firehose Events](README_KinesisFirehose.md)

[S3 Events](README_S3.md)

[SES Events](README_SES.md)

[SNS Events](README_SNS.md)

[SQS Events](README_SQS.md)
